<?php
/*
 * @version $Id: contract_supplierinjection.class.php 725 2012-07-12 05:56:08Z walid $
 LICENSE

 This file is part of the datainjection plugin.

 Datainjection plugin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Datainjection plugin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with datainjection. If not, see <http://www.gnu.org/licenses/>.
 --------------------------------------------------------------------------
 @package   datainjection
 @author    the datainjection plugin team
 @copyright Copyright (c) 2010-2011 Order plugin team
 @license   GPLv2+
            http://www.gnu.org/licenses/gpl.txt
 @link      https://forge.indepnet.net/projects/datainjection
 @link      http://www.glpi-project.org/
 @since     2009
 ---------------------------------------------------------------------- */

if (!defined('GLPI_ROOT')) {
   die("Sorry. You can't access directly to this file");
}

class PluginDatainjectionContract_SupplierInjection extends Contract_Supplier
                                               implements PluginDatainjectionInjectionInterface {


   function __construct()  {
      $this->table = getTableForItemType(get_parent_class($this));
   }


   function isPrimaryType() {
      return false;
   }


   function connectedTo() {
      return array();
   }


   function getOptions($primary_type = '') {
      global $LANG;

      $tab[4]['table']        = 'glpi_contracts';
      $tab[4]['field']        = 'name';
      $tab[4]['name']         = $LANG['financial'][1];
      $tab[4]['checktype']    = 'text';
      $tab[4]['displaytype']  = 'dropdown';

      $tab[5]['table']        = 'glpi_suppliers';
      $tab[5]['field']        = 'name';
      $tab[5]['name']         = $LANG['financial'][26];
      $tab[5]['checktype']    = 'text';
      $tab[5]['displaytype']  = 'dropdown';

      return $tab;
   }


   /**
    * Standard method to add an object into glpi

    *
    * @param values fields to add into glpi
    * @param options options used during creation
    *
    * @return an array of IDs of newly created objects : for example array(Computer=>1, Networkport=>10)
   **/
   function addOrUpdateObject($values=array(), $options=array()) {

      $lib = new PluginDatainjectionCommonInjectionLib($this, $values, $options);
      $lib->processAddOrUpdate();
      return $lib->getInjectionResults();
   }


   function addSpecificNeededFields($primary_type, $values) {

      return array(getForeignKeyFieldForTable(getTableForItemType($primary_type)) => $values[$primary_type]['id']);
   }
}

?>